#!/usr/bin/env python

from os import system
from os import chdir

#datalist = ['reged','sido','cina','marti','lucas','lucap']
datalist = ['marti','lucas','lucap']

svmscale_exe = "./libsvm/svm-scale"
convert_py = "./liblinear/tools/convert.py"
convert_test_py = "./liblinear/tools/convert_test.py"
normalize_py = "./liblinear/tools/normalize.py"
model_dir = "./model"

for data in datalist:
    for i in range(3):
    	system("wget -O data/%s%s_text.zip http://www.causality.inf.ethz.ch/data/%s%s_text.zip" % (data, i, data, i))
	system("unzip data/%s%s_text.zip -d data" % (data, i))
	system("rm -f data/%s%s_text.zip" % (data, i))

    if "marti" in data:
	print "Gaussian filtering for MARTI..."
	cmd = """ matlab -r " \
		    cd liblinear/tools/; \
		    clear all; \
		    gaussian('../../data/marti0_train.data'); \
		    quit; \
		    " -nojvm >> ./log/marti.log \
		    """  
    	system(cmd)
	system("mv liblinear/tools/marti0_train.data ./")

    if "marti" in data:
	system("%s marti0_train.data > temp" % (convert_py))
        system("paste -d \  data/%s0_train.targets temp > data/%s0_temp.svm" % (data, data))
    	system("rm temp")
	system("rm marti0_train.data")
    else:
 	system("%s data/%s0_train.data > temp" % (convert_py, data))
    	system("paste -d \  data/%s0_train.targets temp > data/%s0_temp.svm" % (data, data))
    	system("rm temp")

    # Scaling (reged, cina, marti)
    if "reged" in data or "cina" in data:
	print "scaling training data..."
	system("%s -l 0 -u 1 -s %s/%s.range data/%s0_temp.svm > data/%s0_train.svm" % (svmscale_exe, model_dir, data, data, data))
	
    if "marti" in data:
	print "scaling training data..."
	system("%s -l -1 -u 1 data/%s0_temp.svm > data/%s0_train.svm" % (svmscale_exe, data, data))
	
    # Instance-wise normalization
    if "sido" in data or "luca" in data:
	print "instance-wise normalizing..."
	system("%s data/%s0_temp.svm > data/%s0_train.svm" % (normalize_py, data, data))
	
    for i in range(3):
        print "converting format %s%s_test..." % (data, i)
        system("%s data/%s%s_test.data > data/%s%s_test_temp.svm" % (convert_test_py, data, i, data, i))

        # Scaling (reged, cina, marti)
	if "reged" in data or "cina" in data:
	    print "scaling testing data %s%s..." % (data,i)
	    system("%s -r %s/%s.range data/%s%s_test_temp.svm > data/%s%s_test.svm" % (svmscale_exe, model_dir, data, data, i, data, i))
	    system("rm data/%s%s_test_temp.svm" % (data, i))
	
	if "marti" in data:
	    print "scaling testing data %s%s..." % (data,i)
	    system("%s -l -1 -u 1 data/%s%s_test_temp.svm > data/%s%s_test.svm" % (svmscale_exe, data, i, data, i))
	    system("rm data/%s%s_test_temp.svm" % (data, i))

	# Instance-wise normalization
	if "sido" in data or "luca" in data:
	    print "instance-wise normalizing testing data %s%s..." % (data,i)
	    system("%s data/%s%s_test_temp.svm > data/%s%s_test.svm" % (normalize_py, data, i, data, i))
	    system("rm data/%s%s_test_temp.svm" % (data, i))

system("rm data/*temp*")
system("rm data/*.data")
system("rm data/*.param")
system("rm data/*.targets")

