function cv_auc = crossval(label, sample_in, loss)

fold = 5;

sample = full(sample_in);

tempsize = size(sample);
numfeat = tempsize(1);

len = floor(numfeat/fold);

fid = fopen('auc.log', 'a');

cv_auc = 0;

for i = 1:fold
    te_samp = zeros(len, tempsize(2));
    tr_samp = zeros((fold-1)*len, tempsize(2));
    te_label = zeros(len, 1);
    tr_label = zeros((fold-1)*len, 1);
    te_samp = sample(((i-1)*len+1):i*len, :);
    te_label = label(((i-1)*len+1):i*len, :);
    if i == 1
    	tr_samp = sample((i*len+1):(fold-1)*len, :);
	tr_label = label((i*len+1):(fold-1)*len, :);
    elseif i == fold
    	tr_samp = sample(1:(i-1)*len, :);
    	tr_label = label(1:(i-1)*len, :);
    else
    	tr_samp(1:(i-1)*len, :) = sample(1:(i-1)*len, :);
    	tr_label(1:(i-1)*len, :) = label(1:(i-1)*len, :);
	tr_samp(((i-1)*len+1):(fold-1)*len, :) = sample((i*len+1):(fold*len), :);
	tr_label(((i-1)*len+1):(fold-1)*len, :) = label((i*len+1):(fold*len), :);
    end

    dlmwrite('temp', tr_samp, 'delimiter', ' ')

    tr_sample = sparse(tr_samp);
    te_sample = sparse(te_samp);

    if loss == 1
	model = train(tr_label, tr_sample, '-s 3');
    elseif loss == 2
	model = train(tr_label, tr_sample, '-s 2');
    end
    [pred, acc, dec] = predict(te_label, te_sample, model);
    tempauc = auc(pred, te_label, 0 , 1, 0);
    fprintf(fid, '(%f, %f)\n', tempauc, acc);
    cv_auc = cv_auc + tempauc;
end

cv_auc = cv_auc/fold;
fprintf(fid, 'average auc = %f\n\n', cv_auc);
fclose(fid);
