function leaveOneFeat(filepath, loss)

[label, sample] = read_sparse(filepath);

tempsize = size(sample);

numfeat = tempsize(2)

temp_samp = zeros(tempsize(1), (numfeat-1));
%feat = zeros(numfeat-1);
if loss == 1
    acc = train(label, sample, '-s 3 -v 5');
    oriauc = crossval(label, sample, 1);
elseif loss == 2
    acc = train(label, sample, '-s 2 -v 5');
    oriauc = crossval(label, sample, 2);
end

oriacc = mean(acc);

fidacc = fopen('diffacc', 'w+');
fidauc = fopen('diffauc', 'w+');

for i = 1:numfeat
    for j = 1:(numfeat-1)
	feat(j) = j + (j>=i);
    end
    temp_samp = sample(:,feat);

    temp_samp = sparse(temp_samp);

    if loss == 1
    	allacc(i) = train(label, temp_samp, '-s 3 -v 5');
    	allauc(i) = crossval(label, temp_samp, 1);
    elseif loss == 2
    	allacc(i) = train(label, temp_samp, '-s 2 -v 5');
    	allauc(i) = crossval(label, temp_samp, 2);
    end
    diffacc(i) = mean(allacc(i)) - oriacc;
    diffauc(i) = mean(allauc(i)) - oriauc;
    fprintf(fidacc, '%f\n', diffacc(i));
    fprintf(fidauc, '%f\n', diffauc(i));
end

save diffacc diffacc;
save diffauc diffauc;
save allacc allacc;
save allauc allauc;

[u1 i1] = sort(diffacc);
[u2 i2] = sort(diffauc);

dlmwrite('acc.feat', i1, 'delimiter', ' ');
dlmwrite('auc.feat', i2, 'delimiter', ' ');

fclose(fidacc);
fclose(fidauc);

