%function newA = smooth(X, num, dimX, dimY)
function gaussian(datapath)

%load ../marti0/marti0_train.data;
%X = marti0_train;
X = load(datapath)
A = reshape(X, 500, 32, 32);
num = 500;
dimX = 32;
dimY = 32;
SIGMA = 0.1*dimX;

expTerm = exp(-0.5*power(1/SIGMA,2));
kernel = zeros(32);
for i = 1:32
    kernel(i) = power(expTerm, (i-1)*(i-1));
end

newA = zeros(num, dimX, dimY);
for k = 1:num
    tempA = zeros(dimX, dimY);
    for x = 1:dimX
	for y = 1:dimY
	    up = 0;
	    down = 0;
	    for dx = -32:32
		if (x+dx) > 0 && (x+dx) < 33
		    up = up + kernel(abs(dx)+1)*A(k,x+dx,y);
		    down = down + kernel(abs(dx)+1);
		end
	    end
	    tempA(x,y) = up/down;
	end
    end
    for x = 1:dimX
	for y = 1:dimY
	    up = 0;
	    down = 0;
	    for dy = -32:32
		if (y+dy) > 0 && (y+dy) < 33
		    up = up + kernel(abs(dy)+1)*tempA(x,dy+y);
		    down = down + kernel(abs(dy)+1);
		end
	    end
	    newA(k,x,y) = up/down;
	end
    end
end

newX = reshape(newA, num, dimX*dimY);

newD = X - newX;

dlmwrite('marti0_train.data', newD, 'delimiter', ' ', 'precision', 10);
%save newD newD '-ASCII';

